import logging
import sys

_LOG_LEVEL_ = 'INFO'

LOG_FMT = '[%(asctime)s]-[%(name)s]-[line:%(lineno)d] -%(levelname)-4s: %(message)s'
DATE_FMT = '%Y-%m-%d %H:%M:%S'


# pylint: disable=W0603,W1201
def set_level(level):
    global _LOG_LEVEL_
    lv = level.upper()
    if lv in ("DEBUG", "INFO", "WARN", "ERROR"):
        _logger_ = get_logger(level="INFO")
        _logger_.info("global logger set to %s" % lv)
        _LOG_LEVEL_ = lv


def get_logger(tag="eureka-adapter", level=None):
    logger = logging.getLogger(tag)

    _formatter_ = logging.Formatter(fmt=LOG_FMT, datefmt=DATE_FMT)
    screen_handler = logging.StreamHandler(sys.stdout)
    screen_handler.setFormatter(_formatter_)
    if level is not None:
        logger.setLevel(level.upper())
        screen_handler.setLevel(level.upper())
    else:
        logger.setLevel(_LOG_LEVEL_)
        screen_handler.setLevel(_LOG_LEVEL_)

    logger.addHandler(screen_handler)
    return logger
